<?php
/*
Plugin Name: GT Foursquare
Plugin URI: 
Description: This plugin integrates FourSquare with Wordpress.
Version: 1.0
Author: Global Task
Author URI: http://GlobalTaskSoftware.com
*/
 

// Base Options
add_option('wp_gt4sq_feed_url', '');
add_option('wp_gt4sq_feed_count', '5');
add_option('wp_gt4sq_map_enable', '-1');
add_option('wp_gt4sq_list_enable', '-1');
add_option('wp_gt4sq_icon', '');

// Size options
add_option('wp_gt4sq_height', '300');
add_option('wp_gt4sq_width', '400');

// Widget options
add_option('wp_gt4sq_widget_map_enable', '-1');
add_option('wp_gt4sq_widget_list_enable', '-1');
add_option('wp_gt4sq_widget_title', 'Foursquare');
add_option('wp_gt4sq_widget_width', '240');
add_option('wp_gt4sq_widget_height', '240');


/*
 * SHORTCODE
 */
function gt4sq_shortcode($atts) {

	//	Sample CALL
	// 	[gt4sq map_enable="1" list_enable="1" width="450" height="400" count="6" feed_code="BJI35C4F3BO5TX12RN0QBZA2OZ4TTFDV"]


	// Defining a static ID to increment
	static $shortcodeID = 1;

	// Attributes
	extract( shortcode_atts(
		array(
			'map_enable' => get_option('wp_gt4sq_map_enable'),
			'list_enable' => get_option('wp_gt4sq_list_enable'),
			'width' => get_option('wp_gt4sq_width'),
			'height' => get_option('wp_gt4sq_height'),
			'count' => get_option('wp_gt4sq_feed_count'),
			'feed_code' => get_option('wp_gt4sq_feed_url')
		), $atts )
	);
	
	
	$gt4sq_map_enable = $map_enable;
	$gt4sq_list_enable = $list_enable;
	$gt4sq_height = $height;
	$gt4sq_width = $width;
	$gt4sq_counts = $count;
	$gt4sq_feed_URL = $feed_code;
	$gt4sq_icon = get_option('wp_gt4sq_icon');
	$gt4sq_final_feed_URL = 'http://feeds.foursquare.com/history/'.$gt4sq_feed_URL.'.rss';
	
	if(gt4sq_url_exists($gt4sq_final_feed_URL)) {
		$gt4sq_object = simplexml_load_file($gt4sq_final_feed_URL . '?count=' . $gt4sq_counts);
		$items = $gt4sq_object->channel;
		$gt4sq_checkin = $items->item;
	}	


	$gt4sq_credit = "GT FourSquare";

	//Building final output
	$final_output = '<div id="gt4sq_sc_'.$shortcodeID.'" class="gt4sq_wrapper">';
	
	//IF map is enabled
	if ($gt4sq_list_enable == 1)
	{
		
		if(count($gt4sq_checkin)>0) {
			$final_output .= '<ul class="gt4sq_list">';
			$count = 0;
			
			foreach ($gt4sq_checkin as $item) {
				if ($item->link != '') {
					$final_output = $final_output . '<li><a href="'. $item->link .'">' . $item->title . '</a></li>';
					$count++;
					if ($count == $gt4sq_counts) {break;}
				}
			}
			$final_output .= '</ul>';
		}
	}
	
	//IF map is enabled
	if ($gt4sq_map_enable == 1)
	{
		//Defining the MAP div.
		$final_output .= '<div id="gt4sq_sc_map_'.$shortcodeID.'" class="gt4sq_map gt4sq_sc_map" 
						style="width: '.$gt4sq_width.'px; height: '.$gt4sq_height.'px;"></div>';
		
		

		$url = 'http://feeds.foursquare.com/history/'.$gt4sq_feed_URL.'.kml?count='.$gt4sq_counts;
	
  		$fields_count = 4;
  		$feed_to_array = (array) simplexml_load_file($url);
  		$script = '<script type="text/javascript">
					jQuery( document ).ready(function() {
					
						//Initializing locations array
						var locations = [];
						for(var i=0; i<'.$gt4sq_counts.'; i++) {
							locations[i] = [];
							for(var j=0; j<'.$fields_count.'; j++) {
								locations[i][j] = undefined;
							}
						}
				';
	
		$cont = 0;
		
		if(count($feed_to_array['Folder']->Placemark)>0) {
			foreach($feed_to_array['Folder']->Placemark as $item){
				$coord = explode(',',$item->Point->coordinates);
				$latitud = $coord[0];
				$longitud = $coord[1];
				
				$script .='locations['.$cont.'][0] = "'.$item->name.'";';
				$script .='locations['.$cont.'][2] = '.$latitud.';';
				$script .='locations['.$cont.'][1] = '.$longitud.';';
				$script .='locations['.$cont.'][3] = '.$cont.';';
				
				$cont++;
			}
		}
		
		$script .='
						var map = new google.maps.Map(document.getElementById("gt4sq_sc_map_'.$shortcodeID.'"), {
							zoom: 12,
							mapTypeId: google.maps.MapTypeId.ROADMAP
						});
			
						//create empty LatLngBounds object
						var bounds = new google.maps.LatLngBounds();
						var infowindow = new google.maps.InfoWindow();
						var marker, i;
						var image = \''.$gt4sq_icon.'\';
			
						for (i = 0; i < locations.length; i++) {  
							marker = new google.maps.Marker({
								position: new google.maps.LatLng(locations[i][1], locations[i][2]),
								map: map,
								icon: image
							});
							
							//extend the bounds to include each marker position
							bounds.extend(marker.position);
			
							google.maps.event.addListener(marker, "click", (function(marker, i) {
								return function() {
									infowindow.setContent(locations[i][0]);
									infowindow.open(map, marker);
								}
							})(marker, i));
						}
						
						//now fit the map to the newly inclusive bounds
						map.fitBounds(bounds);
				
					});
				</script>';
		
		//Building the final outpu
		$final_output .= $script;
	}

	//Closing the main wrapper
	$final_output .= '</div>';
	
	//Incrementing static ID
	$shortcodeID++;

	//Returning final output
	return $final_output;
}


/*
 * WIDGET
 */
function wp_gt4sq_widget()
{
	// Register google maps plugin
	wp_register_script( 'gt4sq-gmaps', 'http://maps.google.com/maps/api/js?sensor=false' );
	wp_enqueue_script( 'gt4sq-gmaps' );
	add_action( 'gt4sq-gmaps', 'wptuts_scripts_basic' );
	
	//Setting the options
	$gt4sq_widget_map_enable = get_option('wp_gt4sq_widget_map_enable');
	$gt4sq_widget_list_enable = get_option('wp_gt4sq_widget_list_enable');
	$gt4sq_widget_height = get_option('wp_gt4sq_widget_height');
	$gt4sq_widget_width = get_option('wp_gt4sq_widget_width');
	$gt4sq_feed_URL = get_option('wp_gt4sq_feed_url');
	$gt4sq_counts = get_option('wp_gt4sq_feed_count');
	$gt4sq_icon = get_option('wp_gt4sq_icon');
	$gt4sq_final_feed_URL = 'http://feeds.foursquare.com/history/'.$gt4sq_feed_URL.'.rss';
	$gt4sq_credit = "GT Foursquare";
	
	
	if(gt4sq_url_exists($gt4sq_final_feed_URL)) {
		$gt4sq_object = simplexml_load_file($gt4sq_final_feed_URL . '?count=' . $gt4sq_counts);
		$items = $gt4sq_object->channel;
		$gt4sq_checkin = $items->item;
	}



	//Check if LIST option is enabled
	if ($gt4sq_widget_list_enable == 1)
	{
		if(count($gt4sq_checkin)>0) {
			//Building the UL List
			$final_output = '<ul class="gt4sq_list">';
			$count = 0;
			foreach ($gt4sq_checkin as $item) {
				if ($item->link != '') {
					$final_output = $final_output . '<li><a href="'. $item->link .'">' . $item->title . '</a></li>';
				$count++;
				if ($count == $gt4sq_counts) {break;}
				}
			}
			$final_output .= '</ul>';
		}
	}
		
	
	//Check if MAP option is enabled
	$url = 'http://feeds.foursquare.com/history/'.$gt4sq_feed_URL.'.kml?count='.$gt4sq_counts;
	if ($gt4sq_widget_map_enable == 1 && gt4sq_url_exists($url))
	{
		//Defining the MAP div.
		$final_output .= '<div id="gt4sq_widget_map" class="gt4sq_map gt4sq_widget_map" 
						style="width: '.$gt4sq_widget_width.'px; height: '.$gt4sq_widget_height.'px;"></div>';
						
  		$fields_count = 4;
  		$use_errors = libxml_use_internal_errors(true);
  		$feed_to_array = (array)simplexml_load_file($url);
  		$script = '<script type="text/javascript">
					jQuery( document ).ready(function() {
					
						//Initializing locations array
						var locations = [];
						for(var i=0; i<'.$gt4sq_counts.'; i++) {
							locations[i] = [];
							for(var j=0; j<'.$fields_count.'; j++) {
								locations[i][j] = undefined;
							}
						}
				';
	
		if(count($feed_to_array['Folder']->Placemark)>0) {
			$cont = 0;
			foreach($feed_to_array['Folder']->Placemark as $item){
				$coord = explode(',',$item->Point->coordinates);
				$latitud = $coord[0];
				$longitud = $coord[1];
				
				$script .='locations['.$cont.'][0] = "'.$item->name.'";';
				$script .='locations['.$cont.'][2] = '.$latitud.';';
				$script .='locations['.$cont.'][1] = '.$longitud.';';
				$script .='locations['.$cont.'][3] = '.$cont.';';
				
				$cont++;
			}
		}
		
		$script .='
						var map = new google.maps.Map(document.getElementById("gt4sq_widget_map"), {
							zoom: 12,
							mapTypeId: google.maps.MapTypeId.ROADMAP
						});
			
						//create empty LatLngBounds object
						var bounds = new google.maps.LatLngBounds();
						var infowindow = new google.maps.InfoWindow();
						var marker, i;
						var image = \''.$gt4sq_icon.'\';
			
						for (i = 0; i < locations.length; i++) {  
							marker = new google.maps.Marker({
								position: new google.maps.LatLng(locations[i][1], locations[i][2]),
								map: map,
								icon: image
							});
							
							//extend the bounds to include each marker position
							bounds.extend(marker.position);
			
							google.maps.event.addListener(marker, "click", (function(marker, i) {
								return function() {
									infowindow.setContent(locations[i][0]);
									infowindow.open(map, marker);
								}
							})(marker, i));
						}
						
						//now fit the map to the newly inclusive bounds
						map.fitBounds(bounds);
				
					});
				</script>';
		
		//Building the final outpu
		$final_output .= $script;
	}	

	//Returning
	return $final_output;
}



/*
 * Adding the options page
 */
function wp_gt4sq_add_option_page() {
    if (function_exists('add_options_page')) {
        add_options_page('GT Foursquare', 'GT Foursquare', 8, __FILE__, 'wp_gt4sq_options_page');
    }
}


/*
 * OPTIONS PAGE
 */
function wp_gt4sq_options_page() {

    if (isset($_POST['info_update']))
    {
		update_option('wp_gt4sq_feed_url', stripslashes_deep((string)$_POST["wp_gt4sq_feed_url"]));
        update_option('wp_gt4sq_feed_count', (string)$_POST["wp_gt4sq_feed_count"]);
        update_option('wp_gt4sq_icon', (string)$_POST["wp_gt4sq_icon"]);

		update_option('wp_gt4sq_map_enable', ($_POST['wp_gt4sq_map_enable']=='1') ? '1':'-1' );
		update_option('wp_gt4sq_list_enable', ($_POST['wp_gt4sq_list_enable']=='1') ? '1':'-1' );
		update_option('wp_gt4sq_height', (string)$_POST['wp_gt4sq_height']);
		update_option('wp_gt4sq_width', (string)$_POST['wp_gt4sq_width']);

		update_option('wp_gt4sq_widget_map_enable', ($_POST['wp_gt4sq_widget_map_enable']=='1') ? '1':'-1' );
		update_option('wp_gt4sq_widget_list_enable', ($_POST['wp_gt4sq_widget_list_enable']=='1') ? '1':'-1' );
        update_option('wp_gt4sq_widget_title', (string)$_POST["wp_gt4sq_widget_title"]);
        update_option('wp_gt4sq_widget_width', (string)$_POST["wp_gt4sq_widget_width"]);
        update_option('wp_gt4sq_widget_height', (string)$_POST["wp_gt4sq_widget_height"]);

        echo '<div id="message" class="updated fade"><p><strong>Settings Updated.</strong></p></div>';
        echo '</strong>';
    }

	$icon_url = get_bloginfo( 'wpurl' );
  	$fsq_icon = '<img border="0" src="'.$icon_url.'/wp-content/plugins/gt4sq/images/4sq.jpg" /> ';
   	$new_icon = '<img border="0" src="'.$icon_url.'/wp-content/plugins/gt4sq/images/new.gif" /> ';

	
	// Require settings page
    require_once (dirname(__FILE__) . '/includes/settings-page.php');
}


/*
 * Profile Widget
 */
function show_wp_gt4sq_profile_widget($args)
{
	extract($args);
	$wp_gt4sq_widget_title1 = get_option('wp_gt4sq_widget_title');
	echo $before_widget;
	echo $before_title . $wp_gt4sq_widget_title1 . $after_title;
    echo wp_gt4sq_widget();
    echo $after_widget;
}

function wp_gt4sq_profile_widget_control()
{
    ?>
    <p>
    <? _e("Please go to <b>Settings -> GT Foursquare</b> for options. <br><br> 
    Available options: <br> 
    1) Widget Title <br> 
    2) Widget Width  <br> 
    3) Widget Height <br> 
    4) Enable Map <br> 
    5) Enable List"); ?>
    </p>
    <?php
}

function widget_wp_gt4sq_profile_init()
{
    $widget_options = array('classname' => 'widget_wp_gt4sq_profile', 
    						'description' => __( "Display GT Foursquare Widget") );
    wp_register_sidebar_widget('wp_gt4sq_profile_widgets', __('GT Foursquare'), 
    							'show_wp_gt4sq_profile_widget', $widget_options);
    wp_register_widget_control('wp_gt4sq_profile_widgets', __('GT Foursquare'), 'wp_gt4sq_profile_widget_control' );
}


/*
 * Check if URL exists
 */
function gt4sq_url_exists($url) {
	$file_headers = @get_headers($url);
	if($file_headers[0] == 'HTTP/1.1 404 Not Found') {
	    return false;
	}
	else {
	    return true;
	}
}

/*
 * ADMIN init
 */
function gt4sq_plugin_admin_init()
{
	add_action ( 'admin_enqueue_scripts', function () {
        if (is_admin())
            wp_enqueue_media();
    } );

	wp_enqueue_script('jquery');                    // Enque Default jQuery
	wp_enqueue_script('jquery-ui-core');            // Enque Default jQuery UI Core
	wp_enqueue_script('jquery-ui-tabs');            // Enque Default jQuery UI Tabs


    wp_register_script('gt4sq-script1', plugins_url('/js/gt4sq.js', __FILE__));
    wp_enqueue_script('gt4sq-script1');
    

    wp_register_script('gt4sq-script2', plugins_url('/js/tip.js', __FILE__));
    wp_enqueue_script('gt4sq-script2');

    wp_register_style('gt4sq-plugin-css', plugins_url('/css/jquery-ui.css', __FILE__));
    wp_enqueue_style('gt4sq-plugin-css');

    wp_register_style('gt4sq-tip-plugin-css', plugins_url('/css/jquery.powertip.css', __FILE__));
    wp_enqueue_style('gt4sq-tip-plugin-css');

    wp_register_style('gt4sq-member-plugin-css', plugins_url('/css/gt4sq.css', __FILE__));
    wp_enqueue_style('gt4sq-member-plugin-css');
}


/*
 * Adding the ACTIONS and Shortcode
 */
add_action('admin_menu', 'gt4sq_plugin_admin_init');
add_action('init', 'widget_wp_gt4sq_profile_init');
add_action('admin_menu', 'wp_gt4sq_add_option_page');
add_shortcode( 'gt4sq', 'gt4sq_shortcode' );

?>