<?php
/**
 * @author Global Task
 * Plugin: GT Foursquare
 */
?>

<div class="gt4sq_settings_wrapper">
	<h1>GT Foursquare Settings</h1>

	<p>Welcome to the GT Foursquare plugin settings page. Here you can set the main settings to integrate Foursuqare with Wordpress. With this plugin you can insert a <strong>widget</strong> and multiple <strong>shortcodes</strong>.<br/>
	</p>
	<h2>Inserting a widget</h2>
	<p>To insert the widget, go to <strong>Appearance</strong> &gt;&gt; <strong>Widgets</strong>, and look for the <strong>GT Foursquare</strong> widget.
	</p>
	
	<h2>Using the shortcodes</h2>
	<p>Inserting a <strong>shortcode</strong> is straightforward. While editing a content, right in the textarea you can insert the shortcode and specify the desired options. If none are specified, the default settings from this page will be used.
	</p>
	<p>
	<u>These are some samples of valid shortcodes:</u>
	</p>
	<ul>
		<li><code>[gt4sq]</code></li>
		<li><code>[gt4sq map_enable="1" width="450" height="300"]</code></li>
		<li><code>[gt4sq map_enable="1" list_enable="1" width="250" height="250" count="5"]</code></li>
	</ul>
	
	<!-- LEFT COLUMN -->
	<div class="left-column">
	   	<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
    	<input type="hidden" name="info_update" id="info_update" value="true" />
    	<?php require_once 'setting-page/gt4sq-left-column.php'; ?>
    	
    	<!-- SUBMIT BUTTON -->
		<div class="submit">
			<input name="my_squarez_update_setting" type="hidden"
				value="<?php echo wp_create_nonce('square-update-setting'); ?>" /> 
			<input type="submit" name="info_update" class="button-primary"
				value="<?php _e('Update options'); ?> &raquo;" />
		</div>
	    
    	
    	</form>
    </div>
    
    
	<!--  RIGHT COLUMN -->
	<div class="right-column">
		<div class="postbox">
		  <h3 class="hndle">&nbsp;GT Foursquare</h3>
		  <div class="inside">
	        <ul>
	        	<li>
	        		<a href="http://GlobalTaskSoftware.com" 
	        			title="GT FourSquare" target="_blank">Global Task Homepage</a>
	        	</li>
	        </ul>
	      </div>
		</div>
	</div>
                  
                  
                  
                  
                  
	<!-- FOOTER -->
    <div class="clear">
          <p>
              <br/>&copy; Copyright 2014 - <?php echo date("Y"); ?> 
              <a href="http://GlobalTaskSoftware.com" target="_blank">Global Task</a>
          </p>
    </div>
</div>